var rootUrl = "https://api.99jiankangtong.com/healthy";
var imagesUrl = "http://101.132.71.193/images";
var Config = function() {
	this.homeUrl = "html/home/index.html";
	this.gongjuUrl = "html/gongju/index.html";
	this.zixunUrl = "html/zixun/index.html";
	this.myUrl = "html/my/index.html";
}
Date.prototype.Format = function(fmt) {//author: meizz
	var o = {
		"M+" : this.getMonth() + 1, //月份
		"d+" : this.getDate(), //日
		"h+" : this.getHours(), //小时
		"m+" : this.getMinutes(), //分
		"s+" : this.getSeconds(), //秒
		"q+" : Math.floor((this.getMonth() + 3) / 3), //季度
		"S" : this.getMilliseconds() //毫秒
	};
	if (/(y+)/.test(fmt))
		fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
	for (var k in o)
	if (new RegExp("(" + k + ")").test(fmt))
		fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
	return fmt;
}
/**
 *全局工具
 */
var G = {
	/**
	 *统一的请求_POST
	 * @param {Object} action 具体的方法，省略app路径
	 * @param {Object} params 参数，json格式
	 * @param {Object} fn 回调方法
	 */
	RQP : function(action, params, fn) {
		api.getPrefs({
			key : 'user'
		}, function(ret, err) {
			api.ajax({
				url : rootUrl +action,
				method : 'post',
				headers : {
				    "Content-Type":'application/json; charset=utf-8',
					"healthycard-token" : ret.value!=""?JSON.parse(ret.value).token:"",
					"HEALTHTCARD-PACKAGE" : "com.wondersgroup.xa.healthycard"
				},
				data : {
					body : params
				}
			}, function(ret, err) {
				//alert(JSON.stringify(ret));
				//alert(JSON.stringify(err));
			    api.hideProgress();
				if (err==undefined||err=="") {
					if (fn != undefined)
						fn(ret);
				} else {
					if (err.statusCode == 403) {
					    api.toast({
							msg : '您尚未登陆，请先登录！',
							duration : 2000,
							location : 'bottom'
						});
						api.setPrefs({
						  key : 'user',
						  value : ''
					    });
					    var db = api.require('db');
						db.openDatabase({
							name : 'user'
						}, function(ret, err) {
							  db.executeSql({
								name : 'user',
								sql : 'delete from USERINFO'
							    }, function(ret, err) {
						      });
					    });							
						api.openFrame({
							name : 'login',
							url : '../../html/login.html',
							rect : {
								  x : 0,
								  y : 0,
								  w : 'auto',
								 h : 'auto'
							}
						}); 
					} else if (err.statusCode == 500){
						api.toast({
							msg : JSON.parse(err.msg).ErrorMsg,
							duration : 2000,
							location : 'bottom'
						});
					}
					else{
						api.toast({
							msg : err.msg,
							duration : 2000,
							location : 'bottom'
						});
					}
				}
			});
		});

	},
	/**
	 *统一的请求_GET
	 * @param {Object} action 具体的方法，省略app路径
	 * @param {Object} fn 回调方法
	 */
	RQG : function(action, fn) {
		api.getPrefs({
			key : 'user'
		}, function(ret, err) {
			api.ajax({
				url : encodeURI(rootUrl +action),
				method : 'get',
				headers : {
				    "Content-Type":'application/json; charset=utf-8',
					"healthycard-token" : ret.value!=""?JSON.parse(ret.value).token:"",
					"HEALTHTCARD-PACKAGE" : "com.wondersgroup.xa.healthycard"
				}
			}, function(ret, err) {
				//alert(JSON.stringify(ret));
				//alert(JSON.stringify(err));
			    api.hideProgress();
				if (err==undefined||err=="") {
					if (fn != undefined)
						fn(ret);
				} else {
					if (err.statusCode == 403) {
					    api.toast({
							msg : '您尚未登陆，请先登录！',
							duration : 2000,
							location : 'bottom'
						});
						api.setPrefs({
						  key : 'user',
						  value : ''
					    });
					    var db = api.require('db');
						db.openDatabase({
							name : 'user'
						}, function(ret, err) {
							  db.executeSql({
								name : 'user',
								sql : 'delete from USERINFO'
							    }, function(ret, err) {
						      });
					    });	
						api.openFrame({
							name : 'login',
							url : '../../html/login.html',
							rect : {
								  x : 0,
								  y : 0,
								  w : 'auto',
								 h : 'auto'
							}
						}); 
					} else if (err.statusCode == 500){
						api.toast({
							msg : JSON.parse(err.msg).ErrorMsg,
							duration : 2000,
							location : 'bottom'
						});
					}
					else{
						api.toast({
							msg : "服务器暂无信息",
							duration : 2000,
							location : 'bottom'
						});
					}
				}
			});
		});

	},
	/**
	 * 图表工厂
	 * parm:domId 图表容器ID
	 * parm:options 符合Echarts的option参数
	 *****/
	newChart : function(domId, options) {
		// 基于准备好的dom，初始化echarts实例
		var myChart = echarts.init(document.getElementById(domId));
		//*必须，绑定图表自适应功能
		window.onresize = function() {
			myChart.resize();
			//使第一个图表适应
		}
		// 使用刚指定的配置项和数据显示图表。
		myChart.setOption(options, true);
	},
	/**
	 基础工具：去除undefined
	 */
	noUndefined : function(val) {
		if ( typeof (val) == "undefined") {
			return "0";
		}
		return val;
	},
	/**
	 支付组件：订单标题、金额、描述、回调方法(function)
	 */
//	pay : function(yljg,title, money, desc, orderTitle,fn) {
//	    var payArray=new Array();
//		var MNActionButton = api.require('MNActionButton');
//		MNActionButton.open({
//			layout : {
//				row : 1,
//				col : 3,
//				rowSpacing : 5,
//				colSpacing : 10,
//				offset : 0
//			},
//			animation : true,
//			autoHide : true,
//			styles : {
//				maskBg : 'rgba(0,0,0,0.2)',
//				bg : '#eeeeee',
//				cancelButton : {
//					size : 44,
//					bg : '#eeeeee',
//					icon : 'widget://res/icon/cancel.png'
//				},
//				item : {
//					titleColor : '#888',
//					titleHighlight : 'dd2727',
//					titleSize : 12
//				},
//				indicator : {
//					color : '#c4c4c4',
//					highlight : '#9e9e9e'
//				}
//			},
//			items : [{
//				icon : 'widget://res/icon/wechat.png',
//				highlight : 'widget://res/icon/wechat.png',
//				title : '微信'
//			}, {
//				icon : 'widget://res/icon/alipay.png',
//				highlight : 'widget://res/icon/alipay.png',
//				title : '支付宝'
//			}, {
//				icon : 'widget://res/icon/unionpay.png',
//				highlight : 'widget://res/icon/unionpay.png',
//				title : '银联'
//			}]
//		}, function(ret) {
//			if (ret) {
//				var ret = eval(ret);
//				if (ret.eventType == "click") {
//					var requestJson = {};
//					var wdpay = api.require('wdPay');
//					requestJson.appId = yljg.appid;
//					requestJson.submerno = yljg.submerno;
//					requestJson.appsecret = yljg.appkey;
//					requestJson.money = Math.abs(money * 100);
//					requestJson.goodsTitle = title;
//					requestJson.goodsDesc = desc;
//					requestJson.orderTitle = orderTitle;
//					requestJson.position = ret.index;
//					requestJson.CT='CT';
//					var result={};
//                  if(ret.index==0&&yljg.wechat!=1){
//                     result.code='FAIL';
//                     result.msg=yljg.JGMC+'不支持微信手机支付';
//                     fn(result);
//                     return;
//                  }else if(ret.index==1&&yljg.alipay!=1){
//                     result.code='FAIL';
//                     result.msg=yljg.JGMC+'不支持支付宝手机支付';
//                     fn(result);
//                     return;                    
//                  }else if(ret.index==2&&yljg.unionpay!=1){
//                     result.code='FAIL';
//                     result.msg=yljg.JGMC+'不支持银联手机支付';
//                     fn(result);
//                     return;            
//                  }
//					wdpay.pay(requestJson, function(ret, err) {
//						fn(ret, err);
//					});
//				}
//			}
//		});
//	},
   pay2 : function(payJson,fn) {
	    var payArray=new Array();
		var MNActionButton = api.require('MNActionButton');
		MNActionButton.open({
			layout : {
				row : 1,
				col : 2,
				rowSpacing : 5,
				colSpacing : 50,
				offset : 0
			},
			animation : true,
			autoHide : true,
			styles : {
				maskBg : 'rgba(0,0,0,0.2)',
				bg : '#eeeeee',
				cancelButton : {
					size : 0,
					bg : '#eeeeee',
					icon : 'widget://res/icon/cancel.png'
				},
				item : {
					titleColor : '#888',
					titleHighlight : 'dd2727',
					titleSize : 12
				},
				indicator : {
					color : '#c4c4c4',
					highlight : '#9e9e9e'
				}
			},
			items : [{
				icon : 'widget://res/icon/wechat.png',
				highlight : 'widget://res/icon/wechat.png',
				title : '微信'
			}, {
				icon : 'widget://res/icon/alipay.png',
				highlight : 'widget://res/icon/alipay.png',
				title : '支付宝'
			}]
		}, function(ret) {
			if (ret) {
				var ret = eval(ret);
				if (ret.eventType == "click") {
					var requestJson = {};
					var wdpay = api.require('wdPay');
					
					requestJson.appId = payJson.yljg.appid;
					if(payJson.yljg.submerno==''){
					  requestJson.submerno = payJson.yljg.appid;
					}else{
					  requestJson.submerno = payJson.yljg.submerno;
					}
					requestJson.appsecret = payJson.yljg.appkey;
					requestJson.money = Math.abs(payJson.pay.money * 100);
					requestJson.goodsTitle = payJson.pay.goodsTitle;
					requestJson.goodsDesc = payJson.pay.goodsDesc;
					requestJson.orderTitle = payJson.pay.titleNo;
					requestJson.position = ret.index;
					requestJson.CT='CT';
					requestJson.payStyle='CS';
					var result={};
                    if(ret.index==0&&payJson.yljg.wechat!=1){
                       result.code='FAIL';
                       result.msg=payJson.yljg.jgmc+'不支持微信手机支付';
                       fn(result);
                       return;
                    }else if(ret.index==1&&payJson.yljg.alipay!=1){
                       result.code='FAIL';
                       result.msg=payJson.yljg.jgmc+'不支持支付宝手机支付';
                       fn(result);
                       return;                    
                    }
                   
					wdpay.pay(requestJson, function(ret, err) {
					    if (ret.code != 'SUCCESS') {
					      api.toast({
						     msg : ret.err!=null&&ret.err!=undefined?ret.err:ret.msg
					      });
					      return;
					    }
						fn(ret, err);
					});
				}
			}
		});
	},	
	checkYljgCardInfo : function(card,yljg, callback) {
	    var request = {};
	    request.TransCode = '1002';
		request.CardNo = card.CardNo;
		request.CardTypeID = card.CardTypeID;
		request.Password = card.Password;
	    G.RQP("/his/api/"+yljg.jgdm,request,function(ret){
	       if (ret.ResultCode == 0) {
				callback(ret);
			} else if (ret.ResultCode == -2) {
				api.confirm({
					title : '提示',
					msg : '您尚未在' + yljg.jgmc+ "建立就诊档案，系统将自动建立就诊档案?",
					buttons : ['了解','']
				}, function(ret, err) {
					api.showProgress({
						title : '请稍后片刻...',
						text : '正在建立诊疗档案...',
						modal : true
					});
					var request1003 = {};
					request1003.TransCode = '1003';
					request1003.CardNo = card.CardNo;
					request1003.CardTypeID = card.CardTypeID;
					request1003.PatientName = card.patientname;
					request1003.PatientSexID = card.sex;
					request1003.National = card.national;
					request1003.Birthday = card.birthday;
					request1003.PatientAge = card.patientage;
					request1003.IDCardNo = card.idcardno;
					request1003.Address = card.address;
					request1003.Mobile = card.mobile;
					request1003.Amount = 0.00;
					G.RQP("/his/api/" + yljg.jgdm, request1003, function(ret) {
						api.hideProgress();
						if (ret.ResultCode != 0) {
							api.toast({
								msg : ret.ErrorMsg
							});
						} else {
							callback(ret);
							
						}
					}); 
					
				});
			} else {
				api.toast({
					msg : ret.ErrorMsg
				});
			}
	    });

	},	
	checkYljgZhuyuanInfo : function(card,yljg, callback) {
		var request = {};
		request.TransCode = '5001';
		request.CardNo = card.CardNo;
		request.CardTypeID = card.CardTypeID;
		request.Password = card.Password;
	    G.RQP("/his/api/"+yljg.jgdm,request,function(ret){
	       api.hideProgress();
	       if (ret.ResultCode == 0) {
				callback(ret);
			} else if (ret.ResultCode == -2) {
				api.confirm({
					title : '提示',
					msg : '您尚未在' + yljg.jgmc+ "办理住院登记?",
					buttons : ['了解','']
				}, function(ret, err) {
					
				});
			} else {
				api.toast({
					msg : ret.ErrorMsg
				});
			}
	    });		
	}
};

//随机安全色
function getRandomSafeColor() {
	var base = ['00', '33', '66', '99', 'CC', 'FF'];
	//基础色代码
	var len = base.length;
	//基础色长度
	var bg = new Array();
	//返回的结果
	var random = Math.ceil(Math.random() * 215 + 1);
	//获取1-216之间的随机数
	var res;
	for (var r = 0; r < len; r++) {
		for (var g = 0; g < len; g++) {
			for (var b = 0; b < len; b++) {
				bg.push('#' + base[r].toString() + base[g].toString() + base[b].toString());
			}
		};
	};

	for (var i = 0; i < bg.length; i++) {
		res = bg[random];
	}
	return res;
}

function sendWebsocketEvent(yljgdm, callbackEventName, request) {
	var sendJson = {};
	sendJson.yljgdm = yljgdm;
	sendJson.callbackEventName = callbackEventName;
	sendJson.request = request;
	api.sendEvent({
		name : 'webSocketRequest',
		extra : sendJson
	});
}

var websocketTimeOut
function setWebsocketTimeOut(ms) {
	websocketTimeOut = window.setTimeout(function() {
		api.hideProgress();
		api.toast({
			msg : 'sorry,网络连接超时'
		});
	}, ms);
}

function cleanWebsocketTimeOut() {
	clearTimeout(websocketTimeOut);
}

function openHospital() {
	api.openWin({
		name : 'hospital',
		url : '../common/hospital.html'
	});
}

function openCard() {
	api.openWin({
		name : 'card',
		url : '../common/card.html'
	});
}

function protFactory(url){
	//[封印]路由功能正常后解封，废弃以下过度代码 return "12000"+server;
	var model = url.substring(0,url.indexOf("/"));
	var port = "";
	var his_server = "6011"; // HIS
	var user_server = "8002"; // 用户
	var auth_service = "8018"; //权限
	var drugs_service = ""; //药品库
	var disease_service = ""; //疾病库
	switch(model)
	{
	case "api":
	port=his_server;
	break;
	case "getUserCard":
	port=user_server;
	break;
	default:;
	}
	return ":"+port+"/"
}

function openmeqia(infoParam) {
	var mq = api.require('meiQia');
	mq.setClientInfo(infoParam);
	// 配置初始化美洽需要的appkey
	var param = {
		appkey : "f494e11df30c90a92a029d17e43e5232"
	};

	// 初始化美洽
	mq.initMeiQia(param, function(ret, err) {

		if (ret) {
			// 初始化成功
			// alert(JSON.stringify(ret));
		} else {
			// 初始化失败
			// alert(JSON.stringify(err));
			api.alert({
				title : '错误信息',
				msg : '连接客服失败，请稍后重试！'
			}, function(ret, err) {

			});
		}
		mq.setTitleColor({
			color : "#fffefd"
		});
		mq.setTitleBarColor({
			color : "#00a9e0"
		});
		mq.show();
	});
}